cern.colt.matrix.impl

## Class DenseDoubleMatrix2D

- java.lang.Object
- - cern.colt.PersistentObject
  - - cern.colt.matrix.impl.AbstractMatrix
    - - cern.colt.matrix.impl.AbstractMatrix2D
      - - cern.colt.matrix.DoubleMatrix2D
        - - cern.colt.matrix.impl.DenseDoubleMatrix2D

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable

      public class DenseDoubleMatrix2D
      extends DoubleMatrix2D

  Dense 2-d matrix holding `double` elements. First see the package summary and javadoc tree view to get the broad picture.

  Implementation:

  Internally holds one single contigous one-dimensional array, addressed in row major. Note that this implementation is not synchronized.

  Memory requirements:

  `memory [bytes] = 8*rows()*columns()`. Thus, a 1000*1000 matrix uses 8 MB.

  Time complexity:

  `O(1)` (i.e. constant time) for the basic operations `get`, `getQuick`, `set`, `setQuick` and `size`,

  Cells are internally addressed in row-major. Applications demanding utmost speed can exploit this fact. Setting/getting values in a loop row-by-row is quicker than column-by-column. Thus

         for (int row=0; row < rows; row++) {
                for (int column=0; column < columns; column++) {
                       matrix.setQuick(row,column,someValue);
                }
         }

  is quicker than

         for (int column=0; column < columns; column++) {
                for (int row=0; row < rows; row++) {
                       matrix.setQuick(row,column,someValue);
                }
         }

  Version:
    1.0, 09/24/99
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `DenseDoubleMatrix2D(double[][] values)` Constructs a matrix with a copy of the given values.
    `DenseDoubleMatrix2D(int rows, int columns)` Constructs a matrix with a given number of rows and columns.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `DoubleMatrix2D` | `assign(double value)` Sets all cells to the state specified by `value`.
    `DoubleMatrix2D` | `assign(double[][] values)` Sets all cells to the state specified by `values`.
    `DoubleMatrix2D` | `assign(DoubleFunction function)` Assigns the result of a function to each cell; `x[row,col] = function(x[row,col])`.
    `DoubleMatrix2D` | `assign(DoubleMatrix2D source)` Replaces all cell values of the receiver with the values of another matrix.
    `DoubleMatrix2D` | `assign(DoubleMatrix2D y, DoubleDoubleFunction function)` Assigns the result of a function to each cell; `x[row,col] = function(x[row,col],y[row,col])`.
    `double` | `getQuick(int row, int column)` Returns the matrix cell value at coordinate `[row,column]`.
    `DoubleMatrix2D` | `like(int rows, int columns)` Construct and returns a new empty matrix of the same dynamic type as the receiver, having the specified number of rows and columns.
    `DoubleMatrix1D` | `like1D(int size)` Construct and returns a new 1-d matrix of the corresponding dynamic type, entirelly independent of the receiver.
    `void` | `setQuick(int row, int column, double value)` Sets the matrix cell at coordinate `[row,column]` to the specified value.
    `void` | `zAssign8Neighbors(DoubleMatrix2D B, Double9Function function)` 8 neighbor stencil transformation.
    `DoubleMatrix1D` | `zMult(DoubleMatrix1D y, DoubleMatrix1D z, double alpha, double beta, boolean transposeA)` Linear algebraic matrix-vector multiplication; `z = alpha * A * y + beta*z`.
    `DoubleMatrix2D` | `zMult(DoubleMatrix2D B, DoubleMatrix2D C, double alpha, double beta, boolean transposeA, boolean transposeB)` Linear algebraic matrix-matrix multiplication; `C = alpha * A x B + beta*C`.
    `double` | `zSum()` Returns the sum of all cells; `Sum( x[i,j] )`.

    - ### Methods inherited from class cern.colt.matrix.DoubleMatrix2D

      `aggregate, aggregate, cardinality, copy, equals, equals, forEachNonZero, get, getNonZeros, like, set, toArray, toString, viewColumn, viewColumnFlip, viewDice, viewPart, viewRow, viewRowFlip, viewSelection, viewSelection, viewSorted, viewStrides, zMult, zMult`

    - ### Methods inherited from class cern.colt.matrix.impl.AbstractMatrix2D

      `checkShape, checkShape, columns, rows, size, toStringShort`

    - ### Methods inherited from class cern.colt.matrix.impl.AbstractMatrix

      `ensureCapacity, trimToSize`

    - ### Methods inherited from class cern.colt.PersistentObject

      `clone`

    - ### Methods inherited from class java.lang.Object

      `getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### DenseDoubleMatrix2D

          public DenseDoubleMatrix2D(double[][] values)

      Constructs a matrix with a copy of the given values. `values` is required to have the form `values[row][column]` and have exactly the same number of columns in every row.

      The values are copied. So subsequent changes in `values` are not reflected in the matrix, and vice-versa.

      Parameters:
        `values` - The values to be filled into the new matrix.
      Throws:
        `java.lang.IllegalArgumentException` - if `for any 1 <= row < values.length: values[row].length != values[row-1].length`.

    - #### DenseDoubleMatrix2D

          public DenseDoubleMatrix2D(int rows,
                             int columns)

      Constructs a matrix with a given number of rows and columns. All entries are initially `0`.
      Parameters:
        `rows` - the number of rows the matrix shall have.
        `columns` - the number of columns the matrix shall have.
      Throws:
        `java.lang.IllegalArgumentException` - if `rows<0 || columns<0 || (double)columns*rows > Integer.MAX_VALUE`.

  - ### Method Detail

    - #### assign

          public DoubleMatrix2D assign(double[][] values)

      Sets all cells to the state specified by `values`. `values` is required to have the form `values[row][column]` and have exactly the same number of rows and columns as the receiver.

      The values are copied. So subsequent changes in `values` are not reflected in the matrix, and vice-versa.

      Overrides:
        `assign` in class `DoubleMatrix2D`
      Parameters:
        `values` - the values to be filled into the cells.
      Returns:
        `this` (for convenience only).
      Throws:
        `java.lang.IllegalArgumentException` - if `values.length != rows() || for any 0 <= row < rows(): values[row].length != columns()`.

    - #### assign

          public DoubleMatrix2D assign(double value)

      Sets all cells to the state specified by `value`.
      Overrides:
        `assign` in class `DoubleMatrix2D`
      Parameters:
        `value` - the value to be filled into the cells.
      Returns:
        `this` (for convenience only).

    - #### assign

          public DoubleMatrix2D assign(DoubleFunction function)

      Assigns the result of a function to each cell; `x[row,col] = function(x[row,col])`.

      Example:

          matrix = 2 x 2 matrix
          0.5 1.5
          2.5 3.5

          // change each cell to its sine
          matrix.assign(cern.jet.math.Functions.sin);
          -->
          2 x 2 matrix
          0.479426  0.997495
          0.598472 -0.350783

      For further examples, see the package doc.
      Overrides:
        `assign` in class `DoubleMatrix2D`
      Parameters:
        `function` - a function object taking as argument the current cell's value.
      Returns:
        `this` (for convenience only).
      See Also:
        `Functions`

    - #### assign

          public DoubleMatrix2D assign(DoubleMatrix2D source)

      Replaces all cell values of the receiver with the values of another matrix. Both matrices must have the same number of rows and columns. If both matrices share the same cells (as is the case if they are views derived from the same matrix) and intersect in an ambiguous way, then replaces as if using an intermediate auxiliary deep copy of `other`.
      Overrides:
        `assign` in class `DoubleMatrix2D`
      Parameters:
        `source` - the source matrix to copy from (may be identical to the receiver).
      Returns:
        `this` (for convenience only).
      Throws:
        `java.lang.IllegalArgumentException` - if `columns() != source.columns() || rows() != source.rows()`

    - #### assign

          public DoubleMatrix2D assign(DoubleMatrix2D y,
                              DoubleDoubleFunction function)

      Assigns the result of a function to each cell; `x[row,col] = function(x[row,col],y[row,col])`.

      Example:

          // assign x[row,col] = x[row,col]y[row,col]
          m1 = 2 x 2 matrix
          0 1
          2 3

          m2 = 2 x 2 matrix
          0 2
          4 6

          m1.assign(m2, cern.jet.math.Functions.pow);
          -->
          m1 == 2 x 2 matrix
           1   1
          16 729

      For further examples, see the package doc.
      Overrides:
        `assign` in class `DoubleMatrix2D`
      Parameters:
        `y` - the secondary matrix to operate on.
        `function` - a function object taking as first argument the current cell's value of `this`, and as second argument the current cell's value of `y`,
      Returns:
        `this` (for convenience only).
      Throws:
        `java.lang.IllegalArgumentException` - if `columns() != other.columns() || rows() != other.rows()`
      See Also:
        `Functions`

    - #### getQuick

          public double getQuick(int row,
                        int column)

      Returns the matrix cell value at coordinate `[row,column]`.

      Provided with invalid parameters this method may return invalid objects without throwing any exception. You should only use this method when you are absolutely sure that the coordinate is within bounds. Precondition (unchecked): `0 <= column < columns() && 0 <= row < rows()`.

      Specified by:
        `getQuick` in class `DoubleMatrix2D`
      Parameters:
        `row` - the index of the row-coordinate.
        `column` - the index of the column-coordinate.
      Returns:
        the value at the specified coordinate.

    - #### like

          public DoubleMatrix2D like(int rows,
                            int columns)

      Construct and returns a new empty matrix of the same dynamic type as the receiver, having the specified number of rows and columns. For example, if the receiver is an instance of type `DenseDoubleMatrix2D` the new matrix must also be of type `DenseDoubleMatrix2D`, if the receiver is an instance of type `SparseDoubleMatrix2D` the new matrix must also be of type `SparseDoubleMatrix2D`, etc. In general, the new matrix should have internal parametrization as similar as possible.
      Specified by:
        `like` in class `DoubleMatrix2D`
      Parameters:
        `rows` - the number of rows the matrix shall have.
        `columns` - the number of columns the matrix shall have.
      Returns:
        a new empty matrix of the same dynamic type.

    - #### like1D

          public DoubleMatrix1D like1D(int size)

      Construct and returns a new 1-d matrix of the corresponding dynamic type, entirelly independent of the receiver. For example, if the receiver is an instance of type `DenseDoubleMatrix2D` the new matrix must be of type `DenseDoubleMatrix1D`, if the receiver is an instance of type `SparseDoubleMatrix2D` the new matrix must be of type `SparseDoubleMatrix1D`, etc.
      Specified by:
        `like1D` in class `DoubleMatrix2D`
      Parameters:
        `size` - the number of cells the matrix shall have.
      Returns:
        a new matrix of the corresponding dynamic type.

    - #### setQuick

          public void setQuick(int row,
                      int column,
                      double value)

      Sets the matrix cell at coordinate `[row,column]` to the specified value.

      Provided with invalid parameters this method may access illegal indexes without throwing any exception. You should only use this method when you are absolutely sure that the coordinate is within bounds. Precondition (unchecked): `0 <= column < columns() && 0 <= row < rows()`.

      Specified by:
        `setQuick` in class `DoubleMatrix2D`
      Parameters:
        `row` - the index of the row-coordinate.
        `column` - the index of the column-coordinate.
        `value` - the value to be filled into the specified cell.

    - #### zAssign8Neighbors

          public void zAssign8Neighbors(DoubleMatrix2D B,
                               Double9Function function)

      8 neighbor stencil transformation. For efficient finite difference operations. Applies a function to a moving `3 x 3` window. Does nothing if `rows() < 3 || columns() < 3`.

          B[i,j] = function.apply(
             A[i-1,j-1], A[i-1,j], A[i-1,j+1],
             A[i,  j-1], A[i,  j], A[i,  j+1],
             A[i+1,j-1], A[i+1,j], A[i+1,j+1]
             )

          x x x -     - x x x     - - - -
          x o x -     - x o x     - - - -
          x x x -     - x x x ... - x x x
          - - - -     - - - -     - x o x
          - - - -     - - - -     - x x x

      Make sure that cells of `this` and `B` do not overlap. In case of overlapping views, behaviour is unspecified.

      Example:

          final double alpha = 0.25;
          final double beta = 0.75;

          // 8 neighbors
          cern.colt.function.Double9Function f = new cern.colt.function.Double9Function() {
             public final double apply(
                double a00, double a01, double a02,
                double a10, double a11, double a12,
                double a20, double a21, double a22) {
                   return beta*a11 + alpha*(a00+a01+a02 + a10+a12 + a20+a21+a22);
                }
          };
          A.zAssign8Neighbors(B,f);

          // 4 neighbors
          cern.colt.function.Double9Function g = new cern.colt.function.Double9Function() {
             public final double apply(
                double a00, double a01, double a02,
                double a10, double a11, double a12,
                double a20, double a21, double a22) {
                return beta*a11 + alpha*(a01+a10+a12+a21);
             }
          C.zAssign8Neighbors(B,g); // fast, even though it doesn't look like it
          };

      Overrides:
        `zAssign8Neighbors` in class `DoubleMatrix2D`
      Parameters:
        `B` - the matrix to hold the results.
        `function` - the function to be applied to the 9 cells.
      Throws:
        `java.lang.NullPointerException` - if `function==null`.
        `java.lang.IllegalArgumentException` - if `rows() != B.rows() || columns() != B.columns()`.

    - #### zMult

          public DoubleMatrix1D zMult(DoubleMatrix1D y,
                             DoubleMatrix1D z,
                             double alpha,
                             double beta,
                             boolean transposeA)

      Description copied from class: `DoubleMatrix2D`
      Linear algebraic matrix-vector multiplication; `z = alpha * A * y + beta*z`. `z[i] = alpha*Sum(A[i,j] * y[j]) + beta*z[i], i=0..A.rows()-1, j=0..y.size()-1`. Where `A == this`.
      Note: Matrix shape conformance is checked after potential transpositions.
      Overrides:
        `zMult` in class `DoubleMatrix2D`
      Parameters:
        `y` - the source vector.
        `z` - the vector where results are to be stored. Set this parameter to `null` to indicate that a new result vector shall be constructed.
      Returns:
        z (for convenience only).

    - #### zMult

          public DoubleMatrix2D zMult(DoubleMatrix2D B,
                             DoubleMatrix2D C,
                             double alpha,
                             double beta,
                             boolean transposeA,
                             boolean transposeB)

      Description copied from class: `DoubleMatrix2D`
      Linear algebraic matrix-matrix multiplication; `C = alpha * A x B + beta*C`. `C[i,j] = alpha*Sum(A[i,k] * B[k,j]) + beta*C[i,j], k=0..n-1`.
      Matrix shapes: `A(m x n), B(n x p), C(m x p)`.
      Note: Matrix shape conformance is checked after potential transpositions.
      Overrides:
        `zMult` in class `DoubleMatrix2D`
      Parameters:
        `B` - the second source matrix.
        `C` - the matrix where results are to be stored. Set this parameter to `null` to indicate that a new result matrix shall be constructed.
      Returns:
        C (for convenience only).

    - #### zSum

          public double zSum()

      Returns the sum of all cells; `Sum( x[i,j] )`.
      Overrides:
        `zSum` in class `DoubleMatrix2D`
      Returns:
        the sum.

Jump to the Colt Homepage